% (C) B&M - MLN UPF - 2021

function MLN_NoisePredictionTest()

NMeasures=1000;

Measures = zeros(1,NMeasures);

for i=1:NMeasures
    Measures(i) = NoiseSample(i);
end

%figure
%plot(Measures)
%xlabel('Samples');
%ylabel('Noise (dBs)');

% ----------------------------------------

% (Sensor) [sends only measures that > error] --> (GW) [saves data, storing predictions when no data is received]

TransmittedSample(1) = 1; % Index of the transmitted measurements
TransmittedData(1) = Measures(1); % The first measurement is always transmitted
index=1;
CollectedData(1) = Measures(1); % Data stored at the GW / cloud

for s=2:NMeasures-1
    
    % Can measurement i be predicted ? --------------
    y(s) = NoisePrediction(CollectedData(s-1));
    % -----------------------------------------------
    
    Error(s) = Measures(s) - y(s);
    
    disp('Measure | Prediction | Previous Value | Error');
    disp([Measures(s) y(s) Measures(s-1) Error(s)]);

    if(abs(Error(s)) > 2) % No... we tx the measure
        index = index + 1;
        TransmittedSample(index)=s;
        TransmittedData(index)=Measures(s);
        CollectedData(s)=Measures(s);
    else % Yes
        CollectedData(s)=y(s);
    end    
       
end

figure
plot(TransmittedSample,TransmittedData,'bo');
hold
plot(CollectedData,'rx');
plot(Measures,'g+');
hold
xlabel('Samples');
ylabel('dBs');
legend('Transmitted','Collected','Measures');

end

function Measure = NoiseSample(i)

    Measure = 30 + 0.01.*i + 2.*abs(2.*randn);

end

function y=NoisePrediction(x)

    y=1; % To be Completed
end
